function MassacreNew:SceneTest()
--[[ THIS TEST IS DONE AUTOMATICALLY BY THE GAME NOW; IT SCANS THE SCRIPT FOR ANY MENTIONS OF "GetArea" AND TESTS THE SCENES FOR HAVING THOSE USED AREAS DEFINED!
	-- See if the required areas are present in the test scene
	if not (TestScene:HasArea("LZ Team 1") and TestScene:HasArea("LZ Team 2")) then
		-- If the test scene failed the compatibility test, invalidate it
		TestScene = nil;
	end
--]]
end

function MassacreNew:StartActivity()
	print("START! -- MassacreNew:StartActivity()!");
    for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
        if self:PlayerActive(player) and self:PlayerHuman(player) then
		-- Check if we already have a brain assigned
			if not self:GetPlayerBrain(player) then
				local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
				-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
				if not foundBrain then
					self.ActivityState = Activity.EDITING;
					AudioMan:ClearMusicQueue();
					AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
				else
					-- Set the found brain to be the selected actor at start
					self:SetPlayerBrain(foundBrain, player);
					self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
					self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
					-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
					self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				end
			end
		end
	end

    self.factionA = "Coalition.rte";
    self.factionAActorList = {"Soldier Light", "Soldier Heavy"};
    self.factionACrabList = {"Gatling Drone"};
    self.factionAPrimaryWeaponList = {"Compact Assault Rifle", "Assault Rifle", "Shotgun", "Auto Shotgun", "Breaker-GL", "Gatling Gun", "Sniper Rifle", "Heavy Sniper Rifle", "Flamer", "Auto Cannon", "Revolver Cannon", "Flak Cannon"};
    self.factionASecondaryWeaponList = {"Pistol", "Auto Pistol", "Heavy Pistol"};

    self.factionB = "Dummy.rte";
    self.factionBActorList = {"Dummy"};
    self.factionBCrabList = {"Dreadnought"};
    self.factionBPrimaryWeaponList = {"Blaster", "Nailer Cannon", "Scouting Rifle", "Impulse Cannon", "Repeater", "Destroyer Cannon", "Annihiliator"};
    self.factionBSecondaryWeaponList = {"Nailgun", "Rail Pistol"};

    self.factionC = "Ronin.rte";
    self.factionCActorList = {"Dafred", "Mia", "Dimitri", "Brutus", "Sandra", "Gordon"};
    self.factionCCrabList = {};
    self.factionCPrimaryWeaponList = {"AK-47", "M16", "Shortgun", "Pumpgun", "Spas 12", "Kar98", "M1 Garand", "M60", "Thumper", "RPG-7"};
    self.factionCSecondaryWeaponList = {"Glock", "Desert Eagle", "Peacemaker", "Uzi"};


    self.moduleList = {self.factionA, self.factionB, self.factionC};
    self.actorList = {self.factionAActorList, self.factionBActorList, self.factionCActorList};
    self.crabList = {self.factionACrabList, self.factionBCrabList, self.factionCCrabList};
    self.primaryWeaponList = {self.factionAPrimaryWeaponList, self.factionBPrimaryWeaponList, self.factionCPrimaryWeaponList};
    self.secondaryWeaponList = {self.factionASecondaryWeaponList, self.factionBSecondaryWeaponList, self.factionCSecondaryWeaponList};

	self.ESpawnTimer = Timer();
	self.LZ = SceneMan.Scene:GetArea("LZ Team 1");
	self.EnemyLZ = SceneMan.Scene:GetArea("LZ All");
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.KillsRequired = 10;
		self.killsDisplay = "ten";
		self:SetTeamFunds(10000, Activity.TEAM_1);
		self.BaseSpawnTime = 6000;
		self.RandomSpawnTime = 8000;
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.KillsRequired = 15;
		self.killsDisplay = "fifteen";
		self:SetTeamFunds(5000, Activity.TEAM_1);
		self.BaseSpawnTime = 5500;
		self.RandomSpawnTime = 7000;
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.KillsRequired = 25;
		self.killsDisplay = "twenty-five";
		self:SetTeamFunds(3000, Activity.TEAM_1);
		self.BaseSpawnTime = 5000;
		self.RandomSpawnTime = 6000;
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.KillsRequired = 50;
		self.killsDisplay = "fifty";
		self:SetTeamFunds(2000, Activity.TEAM_1);
		self.BaseSpawnTime = 4500;
		self.RandomSpawnTime = 5000;
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.KillsRequired = 100;
		self.killsDisplay = "one hundred";
		self:SetTeamFunds(1000, Activity.TEAM_1);
		self.BaseSpawnTime = 4000;
		self.RandomSpawnTime = 4500;
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.KillsRequired = 200;
		self.killsDisplay = "two hundred";
		self:SetTeamFunds(1000, Activity.TEAM_1);
		self.BaseSpawnTime = 3500;
		self.RandomSpawnTime = 4000;
	end

	self.StartTimer = Timer();
	
	self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
end

function MassacreNew:PauseActivity(pause)
    	print("PAUSE! -- MassacreNew:PauseActivity()!");
end

function MassacreNew:EndActivity()
    	print("END! -- MassacreNew:EndActivity()!");
		
end

function MassacreNew:UpdateActivity()
	if self.ActivityState ~= Activity.OVER and self.ActivityState ~= Activity.EDITING then
		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				--Display messages.
				if self.StartTimer:IsPastSimMS(3000) then
                    if self.KillsRequired - self:GetTeamDeathCount(Activity.TEAM_2) > 1 then
                        FrameMan:SetScreenText(self.KillsRequired - self:GetTeamDeathCount(Activity.TEAM_2) .. " enemies left!", Activity.PLAYER_1, 0, 1000, false);
                    else
                        FrameMan:SetScreenText("1 enemy left!", Activity.PLAYER_1, 0, 1000, false);
                    end
                else
					FrameMan:SetScreenText("Kill " .. self.killsDisplay .. " enemies!", player, 333, 5000, true);
				end
			
				-- The current player's team
				local team = self:GetTeamOfPlayer(player);
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					self:SetPlayerBrain(nil, player);
					self:ResetMessageTimer(player);
					FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false);
					-- Now see if all brains of self player's team are dead, and if so, end the game
					if not MovableMan:GetFirstBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team);
						ActivityMan:EndActivity();
					end
				end
				
				--Check if the player has won.
				if self:GetTeamDeathCount(Activity.TEAM_2) >= self.KillsRequired then
					self:ResetMessageTimer(player);
					FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("You killed all the attackers!", player, 333, -1, false);
					
					self.WinnerTeam = Activity.TEAM_1;
					
					--Kill all enemies.
					for actor in MovableMan.Actors do
						if actor.Team ~= self.WinnerTeam then
							actor.Health = 0;
						end
					end

					ActivityMan:EndActivity();
				end
			end
		end

		--Spawn the AI.
		if self.ESpawnTimer:LeftTillSimMS(self.TimeLeft) <= 0 and MovableMan:GetMOIDCount() <= 210 then
			local actor = {};
			for x = 0, math.ceil(math.random(3)) do

                local factionPick = math.ceil(math.random()*#self.moduleList);
                if #self.crabList[factionPick] > 0 then
                    if math.random() > 0.05 then
                        actor[x] = CreateAHuman(self.actorList[factionPick][math.ceil(math.random()*#self.actorList[factionPick])],"Non-Colliding Units.rte");
                        actor[x]:AddInventoryItem(CreateHDFirearm(  self.primaryWeaponList[factionPick][math.ceil(math.random()*#self.primaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                        actor[x]:AddInventoryItem(CreateHDFirearm(  self.secondaryWeaponList[factionPick][math.ceil(math.random()*#self.secondaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                        actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
                        actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
                        actor[x].Team = self.CPUTeam;
                    else
                        actor[x] = CreateACrab(self.crabList[factionPick][math.ceil(math.random()*#self.crabList[factionPick])],self.moduleList[factionPick]);
                        actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
                        actor[x].Team = self.CPUTeam;
                        break;
                    end
                else
                    actor[x] = CreateAHuman(self.actorList[factionPick][math.ceil(math.random()*#self.actorList[factionPick])],"Non-Colliding Units.rte");
                    actor[x]:AddInventoryItem(CreateHDFirearm(  self.primaryWeaponList[factionPick][math.ceil(math.random()*#self.primaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                    actor[x]:AddInventoryItem(CreateHDFirearm(  self.secondaryWeaponList[factionPick][math.ceil(math.random()*#self.secondaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                    actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
                    actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
                    actor[x].Team = self.CPUTeam;
                end

			end
			local ship = nil;
			local z = math.random();
		if z > 0.1 then
			if math.random() > 0.3 then
				ship = CreateACDropShip("Drop Ship MK1","SturdyShips.rte");
			else
				ship = CreateACDropShip("Drop Ship","SturdyShips.rte");
			end
		else
			ship = CreateACRocket("Rocket MK2","SturdyShips.rte");
		end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			ship.Team = 1;
			local w = math.random();
			if w > 0.5 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			MovableMan:AddActor(ship);
			self.ESpawnTimer:Reset();
			self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end
	else
		self.StartTimer:Reset();
	end
end